JsonProperty
Date: 2016-12-03

com.fasterxml.jackson.annotation

## Annotation Type JsonProperty

-     @Target(value={ANNOTATION_TYPE,FIELD,METHOD,PARAMETER})
      @Retention(value=RUNTIME)
      public @interface JsonProperty

  Marker annotation that can be used to define a non-static method as a "setter" or "getter" for a logical property (depending on its signature), or non-static object field to be used (serialized, deserialized) as a logical property.

  Default value ("") indicates that the field name is used as the property name without any modifications, but it can be specified to non-empty value to specify different name. Property name refers to name used externally, as the field name in JSON objects.

  Starting with Jackson 2.6 this annotation may also be used to change serialization of `Enum` like so:

      public enum MyEnum {
          @JsonProperty("theFirstValue") THE_FIRST_VALUE,
          @JsonProperty("another_value") ANOTHER_VALUE;
      }

  as an alternative to using `JsonValue` annotation.

- - ### Optional Element Summary

    Optional Elements
    Modifier and Type | Optional Element and Description
    --- | ---
    `JsonProperty.Access` | `access` Optional property that may be used to change the way visibility of accessors (getter, field-as-getter) and mutators (contructor parameter, setter, field-as-setter) is determined, either so that otherwise non-visible accessors (like private getters) may be used; or that otherwise visible accessors are ignored.
    `java.lang.String` | `defaultValue` Property that may be used to document expected default value for the property: most often used as source information for generating schemas (like JSON Schema or protobuf/thrift schema), or documentation.
    `int` | `index` Property that indicates numerical index of this property (relative to other properties specified for the Object).
    `boolean` | `required` Property that indicates whether a value (which may be explicit null) is expected for property during deserialization or not.
    `java.lang.String` | `value` Defines name of the logical property, i.e.

- - ### Element Detail

    - #### value

          public abstract java.lang.String value

      Defines name of the logical property, i.e. JSON object field name to use for the property. If value is empty String (which is the default), will try to use name of the field that is annotated. Note that there is no default name available for constructor arguments, meaning that Empty String is not a valid value for constructor arguments.
      Default:
        ""

    - #### required

          public abstract boolean required

      Property that indicates whether a value (which may be explicit null) is expected for property during deserialization or not. If expected, `BeanDeserialized` should indicate this as a validity problem (usually by throwing an exception, but this may be sent via problem handlers that can try to rectify the problem, for example, by supplying a default value).

      Note that as of 2.6, this property is only used for Creator Properties, to ensure existence of property value in JSON: for other properties (ones injected using a setter or mutable field), no validation is performed. Support for those cases may be added in future. State of this property is exposed via introspection, and its value is typically used by Schema generators, such as one for JSON Schema.

      Since:
        2.0
      Default:
        false

    - #### index

          public abstract int index

      Property that indicates numerical index of this property (relative to other properties specified for the Object). This index is typically used by binary formats, but may also be useful for schema languages and other tools.
      Since:
        2.4
      Default:
        -1

    - #### defaultValue

          public abstract java.lang.String defaultValue

      Property that may be used to document expected default value for the property: most often used as source information for generating schemas (like JSON Schema or protobuf/thrift schema), or documentation. It may also be used by Jackson extension modules; core jackson databind does not have any automated handling beyond simply exposing this value through bean property introspection.

      It is possible that in future this annotation could be used for value defaulting, and especially for default values of Creator properties, since they support `required()` in 2.6 and above.

      Since:
        2.5
      Default:
        ""

    - #### access

          public abstract JsonProperty.Access access

      Optional property that may be used to change the way visibility of accessors (getter, field-as-getter) and mutators (contructor parameter, setter, field-as-setter) is determined, either so that otherwise non-visible accessors (like private getters) may be used; or that otherwise visible accessors are ignored.

      Default value os `JsonProperty.Access.AUTO` which means that access is determined solely based on visibility and other annotations.

      Since:
        2.6
      Default:
        com.fasterxml.jackson.annotation.JsonProperty.Access.AUTO